package com.simpleclub.firebase_rest_auth

object Constants {
	// Base
	const val TAG = "FLTFirebaseAuthPlugin"
	const val ANDROID = "android"
	const val IOS = "iOS"
	const val MINIMUM_VERSION = "minimumVersion"
	const val INSTALL_APP = "installApp"
	const val PACKAGE_NAME = "packageName"
	const val BUNDLE_ID = "bundleId"
	const val APP_NAME = "appName"

	// Providers
	const val SIGN_IN_METHOD_PASSWORD = "password"
	const val SIGN_IN_METHOD_EMAIL_LINK = "emailLink"
	const val SIGN_IN_METHOD_FACEBOOK = "facebook.com"
	const val SIGN_IN_METHOD_GOOGLE = "google.com"
	const val SIGN_IN_METHOD_TWITTER = "twitter.com"
	const val SIGN_IN_METHOD_GITHUB = "github.com"
	const val SIGN_IN_METHOD_PHONE = "phone"
	const val SIGN_IN_METHOD_OAUTH = "oauth"

	// User
	const val USER = "user"
	const val EMAIL = "email"
	const val NEW_EMAIL = "newEmail"
	const val UID = "uid"
	const val USERNAME = "username"
	const val PASSWORD = "password"
	const val NEW_PASSWORD = "newPassword"
	const val PREVIOUS_EMAIL = "previousEmail"
	const val EMAIL_VERIFIED = "emailVerified"
	const val IS_ANONYMOUS = "isAnonymous"
	const val IS_NEW_USER = "isNewUser"
	const val METADATA = "metadata"
	const val DISPLAY_NAME = "displayName"
	const val PHONE_NUMBER = "phoneNumber"
	const val PHOTO_URL = "photoURL"
	const val PROFILE = "profile"
	const val ADDITIONAL_USER_INFO = "additionalUserInfo"
	const val CREATION_TIME = "creationTime"
	const val LAST_SIGN_IN_TIME = "lastSignInTime"

	// Auth
	const val PROVIDERS = "providers"
	const val PROVIDER_ID = "providerId"
	const val PROVIDER_DATA = "providerData"
	const val AUTH_CREDENTIAL = "authCredential"
	const val CREDENTIAL = "credential"
	const val SECRET = "secret"
	const val REFRESH_TOKEN = "refreshToken"
	const val ID_TOKEN = "idToken"
	const val TOKEN = "token"
	const val ACCESS_TOKEN = "accessToken"
	const val CODE = "code"
	const val RAW_NONCE = "rawNonce"
	const val HANDLE = "handle"
	const val EMAIL_LINK = "emailLink"
	const val VERIFICATION_ID = "verificationId"
	const val SMS_CODE = "smsCode"
	const val URL = "url"
	const val DYNAMIC_LINK_DOMAIN = "dynamicLinkDomain"
	const val LANGUAGE_CODE = "languageCode"
	const val CLAIMS = "claims"
	const val TIMEOUT = "timeout"
	const val AUTH_TIMESTAMP = "authTimestamp"
	const val EXPIRATION_TIMESTAMP = "expirationTimestamp"
	const val ISSUED_AT_TIMESTAMP = "issuedAtTimestamp"
	const val SIGN_IN_METHOD = "signInMethod"
	const val SIGN_IN_PROVIDER = "signInProvider"
	const val SIGN_IN_SECOND_FACTOR = "signInSecondFactor"
	const val FORCE_RESENDING_TOKEN = "forceResendingToken"
	const val FORCE_REFRESH = "forceRefresh"
	const val TOKEN_ONLY = "tokenOnly"
	const val HANDLE_CODE_IN_APP = "handleCodeInApp"
	const val ACTION_CODE_SETTINGS = "actionCodeSettings"
	const val AUTO_RETRIEVED_SMS_CODE_FOR_TESTING = "autoRetrievedSmsCodeForTesting"
}